JUCE: MessageManager Class Reference

JUCE

Classes | Public Member Functions | Static Public Member Functions | List of all members
MessageManager Class Referencefinal
juce_events » messages

This class is in charge of the application's event-dispatch loop. More...

`#include <juce_MessageManager.h>`

## Classes
class | Lock
| A lock you can use to lock the message manager. More...
class | MessageBase
| Internal class used as the base class for all message objects. More...

## Public Member Functions
void | runDispatchLoop ()
| Runs the event dispatch loop until a stop message is posted. More...
void | stopDispatchLoop ()
| Sends a signal that the dispatch loop should terminate. More...
bool | hasStopMessageBeenSent () const noexcept
| Returns true if the stopDispatchLoop() method has been called. More...
bool | runDispatchLoopUntil (int millisecondsToRunFor)
| Synchronously dispatches messages until a given time has elapsed. More...
void * | callFunctionOnMessageThread (MessageCallbackFunction *callback, void *userData)
| Calls a function using the message-thread. More...
bool | isThisTheMessageThread () const noexcept
| Returns true if the caller-thread is the message thread. More...
void | setCurrentThreadAsMessageThread ()
| Called to tell the manager that the current thread is the one that's running the dispatch loop. More...
Thread::ThreadID | getCurrentMessageThread () const noexcept
| Returns the ID of the current message thread, as set by setCurrentThreadAsMessageThread(). More...
bool | currentThreadHasLockedMessageManager () const noexcept
| Returns true if the caller thread has currently got the message manager locked. More...
void | registerBroadcastListener (ActionListener *listener)
| Registers a listener to get told about broadcast messages. More...
void | deregisterBroadcastListener (ActionListener *listener)
| Deregisters a broadcast listener. More...

## Static Public Member Functions
static MessageManager * | getInstance ()
| Returns the global instance of the MessageManager. More...
static MessageManager * | getInstanceWithoutCreating () noexcept
| Returns the global instance of the MessageManager, or nullptr if it doesn't exist. More...
static void | deleteInstance ()
| Deletes the global MessageManager instance. More...
static bool | callAsync (std::function< void()> functionToCall)
| Asynchronously invokes a function or C++11 lambda on the message thread. More...
static bool | existsAndIsLockedByCurrentThread () noexcept
| Returns true if there's an instance of the MessageManager, and if the current thread has the lock on it. More...
static bool | existsAndIsCurrentThread () noexcept
| Returns true if there's an instance of the MessageManager, and if the current thread is running it. More...
static void | broadcastMessage (const String &messageText)
| Sends a message to all other JUCE applications that are running. More...

## Detailed Description

This class is in charge of the application's event-dispatch loop.

See also
  Message, CallbackMessage, MessageManagerLock, JUCEApplication, JUCEApplicationBase

## Member Function Documentation

## ◆ getInstance()

static MessageManager * MessageManager::getInstance | ( |  | ) |
| static

Returns the global instance of the MessageManager.

Referenced by MessageThread::start(), and MessageThread::~MessageThread().

## ◆ getInstanceWithoutCreating()

static MessageManager * MessageManager::getInstanceWithoutCreating | ( |  | ) |
| staticnoexcept

Returns the global instance of the MessageManager, or nullptr if it doesn't exist.

## ◆ deleteInstance()

static void MessageManager::deleteInstance | ( |  | ) |
| static

Deletes the global MessageManager instance.

Does nothing if no instance had been created.

## ◆ runDispatchLoop()

void MessageManager::runDispatchLoop | ( |  | ) |

Runs the event dispatch loop until a stop message is posted.

This method is only intended to be run by the application's startup routine, as it blocks, and will only return after the stopDispatchLoop() method has been used.

See also
  stopDispatchLoop

## ◆ stopDispatchLoop()

void MessageManager::stopDispatchLoop | ( |  | ) |

Sends a signal that the dispatch loop should terminate.

After this is called, the runDispatchLoop() or runDispatchLoopUntil() methods will be interrupted and will return.

See also
  runDispatchLoop

Referenced by MessageThread::~MessageThread().

## ◆ hasStopMessageBeenSent()

bool MessageManager::hasStopMessageBeenSent | ( |  | ) | const
| noexcept

Returns true if the stopDispatchLoop() method has been called.

## ◆ runDispatchLoopUntil()

bool MessageManager::runDispatchLoopUntil | ( | int | millisecondsToRunFor | ) |

Synchronously dispatches messages until a given time has elapsed.

Returns false if a quit message has been posted by a call to stopDispatchLoop(), otherwise returns true.

## ◆ callAsync()

static bool MessageManager::callAsync | ( | std::function< void()> | functionToCall | ) |
| static

Asynchronously invokes a function or C++11 lambda on the message thread.

Returns
  true if the message was successfully posted to the message queue, or false otherwise.

## ◆ callFunctionOnMessageThread()

void * MessageManager::callFunctionOnMessageThread | ( | MessageCallbackFunction * | callback,
|  | void * | userData
| ) |  |

Calls a function using the message-thread.

This can be used by any thread to cause this function to be called-back by the message thread. If it's the message-thread that's calling this method, then the function will just be called; if another thread is calling, a message will be posted to the queue, and this method will block until that message is delivered, the function is called, and the result is returned.

Be careful not to cause any deadlocks with this! It's easy to do - e.g. if the caller thread has a critical section locked, which an unrelated message callback then tries to lock before the message thread gets round to processing this callback.

Parameters

  callback | the function to call - its signature must be void* myCallbackFunction (void*)
  userData | a user-defined pointer that will be passed to the function that gets called

Returns
  the value that the callback function returns.

See also
  MessageManagerLock

## ◆ isThisTheMessageThread()

bool MessageManager::isThisTheMessageThread | ( |  | ) | const
| noexcept

Returns true if the caller-thread is the message thread.

## ◆ setCurrentThreadAsMessageThread()

void MessageManager::setCurrentThreadAsMessageThread | ( |  | ) |

Called to tell the manager that the current thread is the one that's running the dispatch loop.

(Best to ignore this method unless you really know what you're doing..)

See also
  getCurrentMessageThread

Referenced by MessageThread::start().

## ◆ getCurrentMessageThread()

Thread::ThreadID MessageManager::getCurrentMessageThread | ( |  | ) | const
| noexcept

Returns the ID of the current message thread, as set by setCurrentThreadAsMessageThread().

(Best to ignore this method unless you really know what you're doing..)

See also
  setCurrentThreadAsMessageThread

## ◆ currentThreadHasLockedMessageManager()

bool MessageManager::currentThreadHasLockedMessageManager | ( |  | ) | const
| noexcept

Returns true if the caller thread has currently got the message manager locked.

see the MessageManagerLock class for more info about this.

This will be true if the caller is the message thread, because that automatically gains a lock while a message is being dispatched.

## ◆ existsAndIsLockedByCurrentThread()

static bool MessageManager::existsAndIsLockedByCurrentThread | ( |  | ) |
| staticnoexcept

Returns true if there's an instance of the MessageManager, and if the current thread has the lock on it.

## ◆ existsAndIsCurrentThread()

static bool MessageManager::existsAndIsCurrentThread | ( |  | ) |
| staticnoexcept

Returns true if there's an instance of the MessageManager, and if the current thread is running it.

## ◆ broadcastMessage()

static void MessageManager::broadcastMessage | ( | const String & | messageText | ) |
| static

Sends a message to all other JUCE applications that are running.

Parameters

  messageText | the string that will be passed to the actionListenerCallback() method of the broadcast listeners in the other app.

See also
  registerBroadcastListener, ActionListener

## ◆ registerBroadcastListener()

void MessageManager::registerBroadcastListener | ( | ActionListener * | listener | ) |

Registers a listener to get told about broadcast messages.

The actionListenerCallback() callback's string parameter is the message passed into broadcastMessage().

See also
  broadcastMessage

## ◆ deregisterBroadcastListener()

void MessageManager::deregisterBroadcastListener | ( | ActionListener * | listener | ) |

Deregisters a broadcast listener.

The documentation for this class was generated from the following file:

- juce_MessageManager.h